#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <Shlobj.h>
#include "CVidRecDlg.h"
#include "..\ComCtrl\BrowsFolder.h"
#include "..\resource.h"

CVidRecDlg::CVidRecDlg(){
	m_szCapFileName[0] = '\0';		//^t@C
}

CVidRecDlg::~CVidRecDlg(){
}

//R}hnh
void CVidRecDlg::OnOK(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	//^t@C擾
	GetDlgItemText(hDlg,IDC_EDIT_FILE,m_szCapFileName,sizeof(m_szCapFileName));
}

void CVidRecDlg::OnCancel(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
}

void CVidRecDlg::OnBtnFile(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	BROWSEINFO pbi;
	LPITEMIDLIST lpid;
	int lRet = FALSE;

	char default_path[MAX_PATH];
	char get_path[MAX_PATH];
		
	ZeroMemory(&pbi,sizeof(BROWSEINFO));

	/*݂̃pX擾*/
	GetDlgItemText(hDlg,IDC_EDIT_FILE,&default_path[0],MAX_PATH);
		
	pbi.hwndOwner=m_hWnd;
	pbi.pidlRoot = NULL;/*c[̃[gƂȂNameSpaceݒ肷 NULL:fXNgbv*/
	pbi.pszDisplayName = get_path;/*IꂽtH_͂|C^*/
	pbi.lpszTitle = "ۑ̑I";/*_CAÕ^Cg*/
	//pbi.ulFlags;       /*Rg[ԂU镑w肷tO*/
	pbi.lpfn = &BrowseCallbackProc;/*R[obN֐̎w*/
	pbi.lParam = (LPARAM)default_path;/*pXw肷*/
	lpid = SHBrowseForFolder(&pbi);

	if(lpid){
		lRet = SHGetPathFromIDList(lpid,get_path);
		CoTaskMemFree(lpid);
	}

	if(lRet == TRUE){
		SetDlgItemText(hDlg,IDC_EDIT_FILE,get_path);
	}
}

//bZ[Wnh
int CVidRecDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);

	//ݒ肷
	
	//t@Cݒ肷
	SetDlgItemText(hDlg,IDC_EDIT_FILE,m_szCapFileName);

	return 0;
}

int CVidRecDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	switch(GET_WM_COMMAND_ID(wP,lP)){

	case IDOK:
		OnOK(hDlg,msg,wP,lP);
		break;

	case IDCANCEL:
		break;

	case IDC_BTN_FILE:
		OnBtnFile(hDlg,msg,wP,lP);
		break;
	}

	return 0;
}

//bZ[Wv-W[
LRESULT CVidRecDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_DESTROY:
		RemoveProp(hWnd, PTDIGI_DLG_PROP);
		break;
	}

	return 0;
}
