#include <windows.h>

#ifndef DIBSIZE
#define WIDTHBYTES(bits) ((DWORD)(((bits)+31) & (~31)) / 8)
#define DIBWIDTHBYTES(bi) (DWORD)WIDTHBYTES((DWORD)(bi).biWidth * (DWORD)(bi).biBitCount)
#define _DIBSIZE(bi) (DIBWIDTHBYTES(bi) * (DWORD)(bi).biHeight)
#define DIBSIZE(bi) ((bi).biHeight < 0 ? (-1)*(_DIBSIZE(bi)) : _DIBSIZE(bi))
#endif

//////////////////////////////////////////////////////////////////////////////
//RGB32̃rbg}bvRGB24ɕω
//:
//߂l:
BOOL RGB32toRGB24(BITMAPINFOHEADER *pbIn,BITMAPINFOHEADER *pbOut){
	BYTE *pDatIn,*pDatOut;
	int nSizeIn,nSizeOut;
	int i;

	if(pbIn == NULL)return FALSE;
	if(pbOut == NULL)return FALSE;

	if(pbIn->biBitCount != 32)return FALSE;

	//wb_Rs[
	CopyMemory(pbOut,pbIn,sizeof(BITMAPINFOHEADER));
	pbOut->biBitCount = 24;
	pbOut->biSizeImage = (pbOut->biWidth * pbOut->biHeight) / 3;

	pDatIn = (BYTE *)pbIn;// + sizeof(BITMAPINFOHEADER);
	pDatOut = (BYTE *)pbOut;// + sizeof(BITMAPINFOHEADER);

	pDatIn = pDatIn + sizeof(BITMAPINFOHEADER);
	pDatOut = pDatOut + sizeof(BITMAPINFOHEADER);

	nSizeIn = DIBSIZE(*pbIn);
	nSizeOut = DIBSIZE(*pbOut);

	//f[^Rs[
	for(i=0;i<nSizeIn;i+=4){
		*pDatOut = *pDatIn;
		++pDatOut;
		++pDatIn;

		*pDatOut = *pDatIn;
		++pDatOut;
		++pDatIn;

		*pDatOut = *pDatIn;
		++pDatOut;
		++pDatIn;

		++pDatIn;
	}

	return TRUE;
}
