#include <windows.h>
#include "CSprite.h"
#include "..\Util\StrUtil.h"

CSprite::CSprite(){
	m_iWidth = 0;
	m_iHeight = 0;
	m_hBmp = NULL;
	m_hMaskBmp = NULL;
	m_hBmpDC = NULL;
	//m_hMaskBmpDC = NULL;
}

CSprite::~CSprite(){
	Release();
}

//////////////////////////////////////////////////////////////////////////////
//mۂXvCg
//:Ȃ
//߂l:Ȃ
void CSprite::Release(void){
	if(m_hBmp != NULL)DeleteObject(m_hBmp);
	if(m_hMaskBmp != NULL)DeleteObject(m_hMaskBmp);
	if(m_hBmpDC != NULL)DeleteDC(m_hBmpDC);
	//if(m_hMaskBmpDC != NULL)DeleteDC(m_hBmp);

	m_iWidth = 0;
	m_iHeight = 0;
	m_hBmp = NULL;
	m_hMaskBmp = NULL;
	m_hBmpDC = NULL;
	//m_hMaskBmpDC = NULL;
}

//////////////////////////////////////////////////////////////////////////////
//rbg}bvt@C烍[hă}XN쐬
//:filename t@C|C^
//     mask rbg}bṽ}XNF
//߂l:TRUE 
//       FALSE s
BOOL CSprite::CreateSpriteFromFile(char* filename,COLORREF mask){
	
	HWND hWnd = GetDesktopWindow();
	HDC hDC=GetDC(hWnd);

	BITMAP tBmp;
	HDC hdcBmp = NULL,hdcMask = NULL;
	BOOL lRet = FALSE;
	
	HGDIOBJ hBmpOldObj = NULL,hBmpOldMask = NULL;

	//̃\[X
	Release();
	
	//摜ǂݍ
	hdcBmp = CreateCompatibleDC(hDC);
	COLORREF oldBkColor=SetBkColor(hdcBmp,mask);//wiFݒ
	m_hBmp=(HBITMAP)LoadImage(NULL,filename,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
	if(m_hBmp == NULL)goto end_section;
	hBmpOldObj = SelectObject(hdcBmp,m_hBmp);
	
	//TCYۑ
	GetObject(m_hBmp,sizeof(BITMAP),&tBmp);
	m_iWidth=tBmp.bmWidth;
	m_iHeight=tBmp.bmHeight;
	DeleteObject(&tBmp);
	
	//}XN쐬
	hdcMask=CreateCompatibleDC(hDC);
	m_hMaskBmp=CreateBitmap(m_iWidth,m_iHeight,1,1,NULL);
	hBmpOldMask = SelectObject(hdcMask,m_hMaskBmp);
	BitBlt(hdcMask,0,0,m_iWidth,m_iHeight,hdcBmp,0,0,SRCCOPY);
	
	//摜̓ߐFɂ
	SetBkColor(hdcBmp,oldBkColor);
	BitBlt(hdcBmp,0,0,m_iWidth,m_iHeight,hdcMask,0,0,0x00220326);

	//rbg}bv`p̃foCXReLXg쐬
	m_hBmpDC = CreateCompatibleDC(hDC);
	
	lRet = TRUE;

end_section:

	SelectObject(hdcBmp,hBmpOldObj);
	SelectObject(hdcMask,hBmpOldMask);

	if(hDC != NULL)ReleaseDC(hWnd,hDC);
	if(hdcBmp != NULL)DeleteDC(hdcBmp);
	if(hdcMask != NULL)DeleteDC(hdcMask);
	
	return lRet;
}

//////////////////////////////////////////////////////////////////////////////
//\[Xt@C烍[hă}XN쐬
//:hInst CX^Xnh
//     iResourceID ǂݍރrbg}bṽ\[XID
//     mask rbg}bṽ}XNF
//߂l:TRUE 
//       FALSE s
BOOL CSprite::CreateSpriteFromResource(HINSTANCE hInst,int iResourceID,COLORREF mask){
	
	HWND hWnd = GetDesktopWindow();
	HDC hDC=GetDC(hWnd);
	BITMAP tBmp;
	HDC hdcBmp,hdcMask;
	HGDIOBJ hBmpOldObj = NULL,hBmpOldMask = NULL;

	//̃\[X
	Release();
	
	//摜ǂݍ
	hdcBmp = CreateCompatibleDC(hDC);
	COLORREF oldBkColor=SetBkColor(hdcBmp,mask);//wiFݒ
	m_hBmp=(HBITMAP)LoadImage(hInst,MAKEINTRESOURCE(iResourceID),IMAGE_BITMAP,0,0,0);
	if(m_hBmp == NULL)goto end_section;
	hBmpOldObj = SelectObject(hdcBmp,m_hBmp);
	
	//TCYۑ
	GetObject(m_hBmp,sizeof(BITMAP),&tBmp);
	m_iWidth=tBmp.bmWidth;
	m_iHeight=tBmp.bmHeight;
	DeleteObject(&tBmp);
	
	//}XN쐬
	hdcMask=CreateCompatibleDC(hDC);
	m_hMaskBmp=CreateBitmap(m_iWidth,m_iHeight,1,1,NULL);
	hBmpOldMask = SelectObject(hdcMask,m_hMaskBmp);
	BitBlt(hdcMask,0,0,m_iWidth,m_iHeight,hdcBmp,0,0,SRCCOPY);
	
	//摜̓ߐFɂ
	SetBkColor(hdcBmp,oldBkColor);
	BitBlt(hdcBmp,0,0,m_iWidth,m_iHeight,hdcMask,0,0,0x00220326);

	//rbg}bv`p̃foCXReLXg쐬
	m_hBmpDC = CreateCompatibleDC(hDC);

end_section:

	SelectObject(hdcBmp,hBmpOldObj);
	SelectObject(hdcMask,hBmpOldMask);

	if(hDC != NULL)ReleaseDC(hWnd,hDC);
	if(hdcBmp != NULL)DeleteDC(hdcBmp);
	if(hdcMask != NULL)DeleteDC(hdcMask);
	
	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
//`悷
//:hDestDC `foCXReLXg
//     x,y `W
//߂l:Ȃ
void CSprite::Draw(HDC hDestDC,int x,int y)
{
	HGDIOBJ hBmpOldObj = NULL,hBmpOldMask = NULL;
	
	if(m_hMaskBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hMaskBmp);
		BitBlt(hDestDC,x,y,m_iWidth,m_iHeight,m_hBmpDC,0,0,SRCAND);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
	
	if(m_hBmp != NULL){
		hBmpOldMask = SelectObject(m_hBmpDC,m_hBmp);
		BitBlt(hDestDC,x,y,m_iWidth,m_iHeight,m_hBmpDC,0,0,SRCPAINT);
		SelectObject(m_hBmpDC,hBmpOldMask);
	}

}

//////////////////////////////////////////////////////////////////////////////
//wTCYɈL΂ĕ`悷
//:hDestDC `foCXReLXg
//     x,y `W
//		iWidth,iHeiht `TCY
//߂l:Ȃ
void CSprite::DrawStrechBlt(HDC hDestDC,int iStrechMode,int x,int y,int iWidth,int iHeight){
	int iStrechModeOld;
	POINT burshOrgPos;
	HGDIOBJ hBmpOldObj = NULL;

	//Xgb`[hݒ肷
	iStrechModeOld = SetStretchBltMode(hDestDC,iStrechMode);
	if(iStrechMode == HALFTONE){
		SetBrushOrgEx(m_hBmpDC,0,0,&burshOrgPos);
	}
	
	//rbg}bvRs[
	if(m_hMaskBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hMaskBmp);
		StretchBlt(hDestDC,x,y,iWidth,iHeight,m_hBmpDC,0,0,m_iWidth,m_iHeight,SRCAND);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
	
	if(m_hBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hBmp);
		StretchBlt(hDestDC,x,y,iWidth,iHeight,m_hBmpDC,0,0,m_iWidth,m_iHeight,SRCPAINT);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
	
	//̃Xgb`[hɖ߂
	if(iStrechModeOld != 0){
		SetStretchBltMode(hDestDC,iStrechModeOld);
		if(iStrechMode == HALFTONE){
			SetBrushOrgEx(m_hBmpDC,burshOrgPos.x,burshOrgPos.y,NULL);
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//\[X摜̈ꕔ`悷
//:hDestDC `foCXReLXg
//     x,y `W
//     rc `悷錳f͈̔
//߂l:Ȃ
void CSprite::DrawPart(HDC hDestDC,int x,int y,RECT rc){
	
	HGDIOBJ hBmpOldObj = NULL;
	
	if(m_hMaskBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hMaskBmp);
		BitBlt(hDestDC,x,y,rc.right - rc.left,rc.bottom - rc.top,m_hBmpDC,rc.left,rc.top,SRCAND);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
	
	if(m_hBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hBmp);
		BitBlt(hDestDC,x,y,rc.right - rc.left,rc.bottom - rc.top,m_hBmpDC,rc.left,rc.top,SRCPAINT);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
}

//////////////////////////////////////////////////////////////////////////////
//`悷(NbsOL)
//:hDestDC `foCXReLXg
//     x,y `W
//     rc `\Ȕ͈
//߂l:Ȃ
void CSprite::Draw(HDC hDestDC,int x,int y,RECT rc){
	int iWidth,iHeight;
	int sx=0,sy=0;//`悷f̍ItZbg
	HGDIOBJ hBmpOldObj;
	
	//`͈͊Ȍꍇ͕`悵Ȃ
	if((x + m_iWidth ) < rc.left || x > rc.right) return ;
	if((y + m_iHeight ) < rc.top || y > rc.bottom) return ;

	//`TCY߂
	iWidth = m_iWidth;
	if(x < rc.left){
		iWidth = m_iWidth - (rc.left - x);
		sx = m_iWidth - iWidth;
	}
	else{
		if(x + m_iWidth > rc.right){
			iWidth =rc.right - x;
		}
	}

	iHeight = m_iHeight;
	if(y < rc.top){
		iHeight = m_iHeight - (rc.top - y);
		sy = m_iHeight - iHeight;
	}
	else{
		if(y + m_iHeight > rc.bottom){
			iHeight =rc.bottom - y;
		}
	}


	if(m_hMaskBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hMaskBmp);
		BitBlt(hDestDC,x,y,iWidth,iHeight,m_hBmpDC,sx,sy,SRCAND);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
	
	if(m_hBmp != NULL){
		hBmpOldObj = SelectObject(m_hBmpDC,m_hBmp);
		BitBlt(hDestDC,x,y,iWidth,iHeight,m_hBmpDC,sx,sy,SRCPAINT);
		SelectObject(m_hBmpDC,hBmpOldObj);
	}
}

//////////////////////////////////////////////////////////////////////////////
//擾po֐
//:Ȃ
//߂l:rbg}bv̕
int CSprite::GetWidth(void){
	return m_iWidth;
}

//////////////////////////////////////////////////////////////////////////////
//擾po֐
//:Ȃ
//߂l:rbg}bv̍
int CSprite::GetHeight(void){
	return m_iHeight;
}

//////////////////////////////////////////////////////////////////////////////
//擾po֐(//wWɉ摜邩ׂ)
//:XvCg(0,0)ƂXvCg̍W
//߂l:TRUE ɉf
//       FALSE fȂ
BOOL CSprite::IsExist(int x,int y){
	
	BOOL lRet = FALSE;
	HGDIOBJ hBmpOldObj = NULL;

	if(x < 0 || x >= m_iWidth ){
		return FALSE;
	}
	if(y < 0 || y >= m_iHeight ){
		return FALSE;
	}

	hBmpOldObj = SelectObject(m_hBmpDC,m_hMaskBmp);

	if( GetPixel(m_hBmpDC,x,y) == RGB(0,0,0)) lRet = TRUE;
	
	SelectObject(m_hBmpDC,hBmpOldObj);
	
	return lRet;
}

//////////////////////////////////////////////////////////////////////////////
//wW̐F擾
//:XvCg(0,0)ƂXvCg̍W
//߂l:Fl
COLORREF CSprite::GetPixelColor(int x,int y){
	COLORREF col = 0;
	HGDIOBJ hBmpOldObj = NULL;

	if(x < 0  || x >= m_iWidth ) return col;
	if(y < 0  || y >= m_iHeight ) return col;

	hBmpOldObj = SelectObject(m_hBmpDC,m_hBmp);

	col = GetPixel(m_hBmpDC,x,y);
	
	SelectObject(m_hBmpDC,hBmpOldObj);
	
	return col;
}

//////////////////////////////////////////////////////////////////////////////
//`(uh)
//:hDestDC -> `foCXReLXg
//     x,y     -> `W
//     alpha   -> ߗ(0`255)
void CSprite::DrawAlpha(HDC hDestDC,int x,int y,int alpha)
{
	BLENDFUNCTION blend;
	HGDIOBJ hBmpOldObj = NULL;
	HDC hdc = NULL;
	HBITMAP hCopyBmp;

	hdc = GetDC(NULL);

	//BMP쐬
	hCopyBmp=CreateCompatibleBitmap(hdc,m_iWidth,m_iHeight);
	ReleaseDC(NULL,hdc);

	hBmpOldObj = SelectObject(m_hBmpDC,hCopyBmp);

	//]摜Rs[
	BitBlt(m_hBmpDC,0,0,m_iWidth,m_iHeight,hDestDC,x,y,SRCCOPY);

	//]摜ƏBMP֕`
	Draw(m_hBmpDC,0,0);

	//]֍ƏBMP𔼓`
	ZeroMemory(&blend,sizeof(BLENDFUNCTION));
	blend.BlendOp=AC_SRC_OVER;
	blend.BlendFlags=0;
	blend.SourceConstantAlpha=alpha;
	blend.AlphaFormat=0;
	AlphaBlend(hDestDC,x,y,m_iWidth,m_iHeight,m_hBmpDC,0,0,m_iWidth,m_iHeight,blend);

	SelectObject(m_hBmpDC,hBmpOldObj);

	DeleteObject(hCopyBmp);
}